package figure;

//import java.awt.Point;
import java.awt.geom.Point2D;

public class Bound {
	private double x;
	private double y;
	private double width;
	private double height;

	public Bound() {
		this(0.0, 0.0, 0.0, 0.0);
	}

	public Bound(double x, double y, double width, double height) {
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
	}
	
	public double getX() {
		return x;
	}

	public void setX(double x) {
		this.x = x;
	}

	public double getY() {
		return y;
	}

	public void setY(double y) {
		this.y = y;
	}

	public double getWidth() {
		return width;
	}

	public void setWidth(double width) {
		this.width = width;
	}

	public double getHeight() {
		return height;
	}

	public void setHeight(double height) {
		this.height = height;
	}

	@Override
	public String toString() {
		return "Bound [x=" + x + ", y=" + y + ", width=" + width + ", height=" + height + "]";
	}
/*	
	public static Bound findBound(Point[] points) {
		if (points == null) return null;
		double xmin = points[0].getX();
		double xmax = points[0].getX();
		double ymin = points[0].getY();
		double ymax = points[0].getY();
		for (int i=0; i<points.length; i++) {
			xmin = Math.min(points[i].getX(), xmin);
	        xmax = Math.max(points[i].getX(), xmax);
	        ymin = Math.min(points[i].getY(), ymin);
	        ymax = Math.max(points[i].getY(), ymax);
		}
		return new Bound(xmin, ymin, xmax - xmin, ymax - ymin);
	}
*/
	public static Bound findBound(Point2D[] points) {
		if (points == null) return null;
		double xmin = points[0].getX();
		double xmax = points[0].getX();
		double ymin = points[0].getY();
		double ymax = points[0].getY();
		for (int i=0; i<points.length; i++) {
			xmin = Math.min(points[i].getX(), xmin);
	        xmax = Math.max(points[i].getX(), xmax);
	        ymin = Math.min(points[i].getY(), ymin);
	        ymax = Math.max(points[i].getY(), ymax);
		}
		return new Bound(xmin, ymin, xmax - xmin, ymax - ymin);
	}

	public static double findMin(double... array) {
		double min = array[0];
		for (int i=0; i<array.length; i++ ) {
			if (array[i] < min) {
				min = array[i];
			}
		}
		return min;
	}
	
	public static double findMax(double... array) {
		double max = array[0];
		for (int i=0; i<array.length; i++ ) {
			if (array[i] > max) {
				max = array[i];
			}
		}
		return max;
	}
}
