package figure;

import java.awt.Point;
import java.awt.geom.Point2D;

public abstract class Figure implements Area, Perimeter {
	protected Point[] points = null; // 
	protected double[] sides = null; // 
	protected double[] angles = null; // 
	protected Bound bound = null; // ٿڽ
    
	protected Figure() {
	}
	
    protected Figure(Point[] points) {
		this.setPoints(points);
    }

 	public void setPoints(Point[] points) {
		this.points = points;
        //System.out.println("Point " + java.util.Arrays.toString(points));
    	updateBound(points);
    	updateSides(points);
    	updateAngles(points);
    	print();
    }
 	
    public void updateBound(Point[] points) {
		this.bound = Bound.findBound(points);
		//System.out.println(bound);
    }
    
    public void updateSides(Point[] points) {
		if (points == null) return;
		this.sides = new double[points.length];
		for (int i=0; i<points.length; i++) {
			int nextIndex = (i + 1) % points.length;
			//this.sides[i] = Vector.distance(points[i], points[nextIndex]);
			this.sides[i] = Point2D.distance(points[i].getX(), points[i].getY(), points[nextIndex].getX(), points[nextIndex].getY());
		}
		//System.out.println("Side " + java.util.Arrays.toString(sides));
    }
    
    public void updateAngles(Point[] points) {
    	if (points == null) return;
		this.angles = new double[points.length];
		for (int i=0; i<points.length; i++) {
			int prevIndex = i==0 ? (i + points.length - 1) : (i - 1);
			int nextIndex = (i + 1) % points.length;
			this.angles[i] = Vector2D.innerAngle(points[prevIndex], points[i], points[nextIndex]);
		}
		//System.out.println("Angle " + java.util.Arrays.toString(angles));
    }

	public Point[] getPoints() {
		return points;
	}

	public Bound getBound() {
		return bound;
	}

	public double[] getSides() {
		return sides;
	}

	public double[] getAngles() {
		return angles;
	}

    public void print() {
        System.out.println("Point " + java.util.Arrays.toString(points));
        System.out.println("Side " + java.util.Arrays.toString(sides));
        System.out.println("Angle " + java.util.Arrays.toString(angles));
        System.out.println(bound);
    }

	public abstract void getAdditionalUserInput();   
}
