package figure;

public enum QuadrilateralType {
    QUADRILATERAL, // quadrilateral
	RECTANGLE, // rectangle (A rectangle is a parallelogram with four right angles, so all rectangles are also parallelograms and quadrilaterals.)
	TRAPEZOID, // trapezoid (A trapezium is a quadrilateral with exactly one pair of parallel sides and no sides the same.)
	ISOSCELES_TRAPEZOID, // isosceles trapezoid (An isosceles trapezoid is a quadrilateral with exactly one pair of parallel sides and two opposite sides the same.)
	PARALLELOGRAM, // parallelogram (A parallelogram is a quadrilateral in which both pairs of opposite sides are parallel.)
	RHOMBUS, // rhombus (A rhombus is a parallelogram with four congruent sides.)
	KITE, // kite (A kite is a quadrilateral with exactly two pairs of adjacent congruent sides.)
	SQUARE; // square (A square can be defined as a rhombus which is also a rectangle.)

	// get String[] names 
	public static String[] names() {
		String[] names = new String[QuadrilateralType.values().length];
		for (QuadrilateralType n : QuadrilateralType.values()) 
			names[n.ordinal()] = n.toString();
		return names;
	}
}
