package figure;

import java.awt.Point;

public class Trapezoid extends Quadrilateral {
	protected double top;
	protected double bottom;
	protected double height;
	
	public Trapezoid() {
		super();
	}
	
	public Trapezoid(Point[] points) {
		this.setPoints(points);
	}

    @Override
 	public void setPoints(Point[] points) {
		super.setPoints(points);
		//System.out.println("Trapezoid setPoints() vectorDot[0]=" + vectorDot[0] + " sides[0]*sides[2]=" + (sides[0]*sides[2]));
		//System.out.println("Trapezoid setPoints() vectorDot[1]=" + vectorDot[1] + " sides[1]*sides[3]=" + (sides[1]*sides[3]));
		if (vectorDot[0] == Math.round(sides[0] * sides[2] * 100)/100.d) { // sides[0] & sides[2] is parallel
			top = sides[0];
			bottom = sides[2];
			height = sides[1] * Math.sin(Math.toRadians(angles[2]));
		} else if (vectorDot[1] == Math.round(sides[1] * sides[3] * 100)/100.d) { // sides[1] & sides[3] is parallel
			top = sides[3];
			bottom = sides[1];
			height = sides[0] * Math.sin(Math.toRadians(angles[1]));	
		}
    }
    
	//   뺯
	public double getTop() {
		return this.top;
	}
	
	//   뺯
	public double getBottom() {
		return this.bottom;
	}

	// height
	public double getHeight() {
		return this.height;
	}

	@Override
	public double area() {
		return (getTop() + getBottom()) * getHeight() / 2.0;
	}
/*
	@Override
	public FigureMode getMode() {
		return FigureMode.TRAPEZOID;
	}
*/
	@Override
	public String toString() {
		return "Trapezoid [top=" + getTop() + ", bottom=" + getBottom() + ", height=" + getHeight() 
				+ ", area()=" + area() + ", perimeter()=" + perimeter() + "]";
	}
}
