package figure;
import java.awt.Point;
import java.util.List;

public class Triangle extends Figure {
	public static final int TRI = 3;
	
	// default constructor
	public Triangle() {
		super();
	}

	// constructor
	public Triangle(Point[] points) {
		super(points);
	}

	// constructor
    public Triangle(List<Point> points) {
    	Point[] pArray = points.toArray(new Point[points.size()]);
    	this.setPoints(pArray); // must call the override method
	}

	// constructor
	public Triangle(Point a, Point b, Point c) {
		Point[] points = new Point[TRI];
		points[0] = a;
		points[1] = b;
		points[2] = c;
		this.setPoints(points); // must call the override method
	}

	@Override
	public void getAdditionalUserInput() {	
		String[] names = {"Top", "BottomLeft", "BottomRight"};
    	Point[] points = new Point[TRI]; // 3 point 
		for (int i=0; i<TRI; i++) {
			System.out.print("please input triangle point[" + names[i] + "] :"); 
			points[i] = UserInput.getPoint();
		}
    	this.setPoints(points); // must call the override method
	}

	@Override
	// Area =  ab sin C / 2
	public double area() {
		return this.sides[0] * this.sides[1] * Math.sin(Math.toRadians(this.angles[1])) / 2.0;
	}

	@Override
	public double perimeter() {
		return this.sides[0] + this.sides[1] + this.sides[2];
	}
	
	public TriangleType classify() {
		if ((sides[0] == sides[1]) && (sides[0] == sides[2]))
	        return TriangleType.EQUILATERAL_TRIANGLE;
	    else if ((sides[0] == sides[1]) || (sides[0] == sides[2]) || (sides[1] == sides[2]))
	        return TriangleType.ISOSCELES_TRIANGLE;
	    else
	        return TriangleType.SCALENE_TRIANGLE;
	}
	
	public TriangleType classifyByAngle() {
		if (angles[0] == 90 || angles[1] == 90 || angles[2] == 90)
			return TriangleType.RIGHT_TRIANGLE;
		else if (angles[0] < 90 && angles[1] < 90 && angles[2] < 90)
			return TriangleType.ACUTE_TRIANGLE;
		else
			return TriangleType.OBTUS_TRIANGLE;
	}

	@Override
	public String toString() {
		return "Triangle [classify()=" + classify()	+ ", classifyByAngle()=" + classifyByAngle() 
			+ ", area()=" + area() + ", perimeter()=" + perimeter() + "]";
	}
}
