package figure;

import java.awt.Point;
import java.util.Scanner;

public class UserInput {
	static Scanner scan = new Scanner(System.in);
	
	// get user input name
	public static String getName() {
		return scan.nextLine();
	}
	
    // get between min_value and max_value
    public static int getIntegerBetween(int min, int max) {
    	int value = -1;
		do {
			System.out.printf("Please enter the number %d-%d: ", min, max);
       		try {
				value = Integer.parseInt(scan.nextLine());
       		} catch (NumberFormatException e) {
       			System.out.printf("ERROR! Please enter the number %d-%d!\n", min, max);
       			//scan.next();
       			continue;
       		}
       		System.out.printf("You entered %d\n", value);
		} while (value < min || value > max);
        return value;
    }
    
	// get user input integer
	public static int getInteger() {
		int value = 0;
		while(true) {
			try {
				value = Integer.parseInt(scan.nextLine());
				break;
			}
			catch (NumberFormatException e) {
				System.out.print("Error! Please re-enter [int value]: ");
			}
		}
		return value;
	}
	
	// get user input double
	public static double getDouble() {
		double value = 0.0;
		while (true) {
			try {
				value = Double.parseDouble(scan.nextLine());
				break;
			}
			catch (NumberFormatException e) {
				System.out.print("Error! Please re-enter [double value]: ");
			}
		}
		return value;
	}

	// break a loop if 'q'-key is pressed or 'enter'-key to continue
	public static boolean getExitKey() {
		System.out.println("Press q-key to exit"
				+ " or enter-key to continue");

		String input = scan.nextLine();
		if (input == null || input.contentEquals("")) 
			return false;

		if(input.contentEquals("q"))
			return true;
		else
			return false;
	}
/*	
    public static FigureMode getUserFigure() {
    	FigureMode mode = null;
		do {
   			System.out.println("Please select Figure [TRIANGLE, RECTANGLE, TRAPEZOID, PARALLELOGRAM, RHOMBUS]");
       		try {
				String input = scan.nextLine();
				mode = FigureMode.valueOf(input);
				if (mode != null) return mode;
       		} catch (Exception e) {
       			System.out.println("ERROR! Please re-enter!");
       			scan.next();
       		}
		} while (mode == null);
		return mode;
    }
    
    public static CalculateMode getCalculateMode() {
    	CalculateMode mode = null;
		do {
   			System.out.print("Please select [AREA, PERIMETER, BOTH]: ");
       		try {
				String input = scan.nextLine();
				mode = CalculateMode.valueOf(input);
				if (mode != null) return mode;
       		} catch (Exception e) {
       			System.out.println("ERROR! Please re-enter!");
       		}
		} while (mode == null);
		return mode;
    }
   
	// get user input Point
	public static Vector getVector() {
		Vector value = null;
		while(true) {
			String input = scan.nextLine();
			if (input == null || input.contentEquals("")) {
				System.out.print("Error! Please re-enter Point [E.g. 10.0 10.0]: ");
				continue;
			}
			String[] values = input.split(" ");
			try {
				double x = Double.parseDouble(values[0]);
				double y = Double.parseDouble(values[1]);
				value = new Vector(x, y);
				System.out.println(value);
				break;
			}
			catch (NumberFormatException e) {
				System.out.print("Error! Please re-enter Point [E.g. 10.0 10.0]: ");
			}
		}
		return value;
	}
*/	
	// get user input Point
	public static Point getPoint() {
		Point value = null;
		while(true) {
			String input = scan.nextLine();
			if (input == null || input.contentEquals("")) {
				System.out.print("Error! Please re-enter Point [E.g. 10 10]: ");
				continue;
			}
			String[] values = input.split(" ");
			try {
				int x = Integer.parseInt(values[0]);
				int y = Integer.parseInt(values[1]);
				value = new Point(x, y);
				System.out.println(value);
				break;
			}
			catch (NumberFormatException e) {
				System.out.print("Error! Please re-enter Point [E.g. 10 10]: ");
			}
		}
		return value;
	}
}
