package figure;

import java.awt.Point;
import java.awt.geom.Point2D;

public class Vector2D extends Point2D.Double {
	public Vector2D() {
		super();
	}

	public Vector2D(double x, double y) {
		super(x, y);
	}

	// distance = sqrt((p2.x - p1.x)^2 + (p2.y - p1.y)^2)
	public static double distance(Point p1, Point p2) {
		return Math.sqrt((p2.getX() - p1.getX())*(p2.getX() - p1.getX()) + (p2.getY()-p1.getY())*(p2.getY()-p1.getY()));
	}
	
	// length = sqrt(x^2 + y^2)
	public static double length(Point2D p) {
		return Math.sqrt(p.getX()*p.getX() + p.getY()*p.getY());
	}
	
	// dot = p1.x * p2. x + p1.y * p2.y
	public static double dot(Point2D p1, Point2D p2) {
		return p1.getX()*p2.getX() + p1.getY()*p2.getY();
	}
	
	// Angle between two vectors = acos(dot(v1, v2)/|v1|*|v2|)
	public static double innerAngle(Point p1, Point p2, Point p3) {
		// v1 = p1 - p2
		Point2D v1 = new Point2D.Double(p1.getX() - p2.getX(), p1.getY() - p2.getY());
		// v2 = p3 - p2
		Point2D v2 = new Point2D.Double(p3.getX() - p2.getX(), p3.getY() - p2.getY());
		// radian = acos(dot(v1 * v2) / length(v1)*length(v2))
		double len1 = Math.sqrt(v1.getX()*v1.getX() + v1.getY()*v1.getY());
		double len2 = Math.sqrt(v2.getX()*v2.getX() + v2.getY()*v2.getY());
		double angrad = Math.acos(dot(v1, v2)/(len1 * len2));
		return Math.toDegrees(angrad);
	}
	
	// Angle between two vectors = acos(dot(v1, v2)/|v1|*|v2|)
	public static double innerAngle(Point2D p1, Point2D p2, Point2D p3) {
		// v1 = p1 - p2
		Point2D v1 = new Point2D.Double(p1.getX() - p2.getX(), p1.getY() - p2.getY());
		// v2 = p3 - p2
		Point2D v2 = new Point2D.Double(p3.getX() - p2.getX(), p3.getY() - p2.getY());
		// radian = acos(dot(v1 * v2) / length(v1)*length(v2))
		double len1 = Math.sqrt(v1.getX()*v1.getX() + v1.getY()*v1.getY());
		double len2 = Math.sqrt(v2.getX()*v2.getX() + v2.getY()*v2.getY());
		double angrad = Math.acos(dot(v1, v2)/(len1 * len2));
		return Math.toDegrees(angrad);
	}
}
